<?php
/*
 * CLASSE DE PGINAO EM PHP + MYSQL, USANDO A BIBLIOTECA "ADODB"
 * AUTOR : dson Kuzniewski (Br0w)
 * E-MAIL: contato@edsonk.com
 * DATA  : 18/05/2008
 * VERSO: 1.2.0.2
 */
 
/*
 * [ INFO DE ATUALIZAO ]
 *
 * 1 - CORREO DO ESTILO 2 DE PAGINAO;
 */ 

/**
[MODO DE USAR]==============================================================================================\
 //Adicione a classe na pgina no qual ira usar
 require_once("class.Paginacao.php");
 //Crie um sql no qual queira que o resultado seja mostrado com paginao;***********************************
 $sql = "SELECT *
					 FROM tabela
					WHERE se tiver
					ORDER BY id ASC ou DESC";

 $paginacao = new Paginacao();   						//Cria a paginao;
 $paginacao->setMaximo("20");    						//Define numro de itens por pgina se no fica o padro de 10;
 $paginacao->setEstilo("2");		 						//Define o estilo de paginao, mude se quizer 1 ou 2;
 $paginacao->setBtnPrimeiro("[Primeiro]");  //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setBtnUltimo("[ltimo]");      //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setBtnAnterior("[Anterior]");  //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setBtnProximo("[Prximo]");    //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setBtnPrimeiroOn(true);        //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setBtnUltimoOn(true);          //Define texto do boto de padro j est definido mude se quizer;
 $paginacao->setUrlAdicional("id=1&categoria=3&texto=asdfg");  //Define a url adicional passada por parmetro via url opcional;
 $paginacao->setZero(true);									//coloca zero aos nmeros baixos de 10; 01 02... padro ativado (true/false);
 $paginacao->getNporPg();										//RETORNA NMERO DE ITENS POR PGINA
 $paginacao->getNtotalPg();									//RETORNA O NMERO TOTAL DE PGINAS
 $paginacao->__start($db, $sql); 						//Inicia a pginao;
 $i=0;
 while($row = $paginacao->getResult()->FetchNextObject()){
 		echo"linha com item n $i";
		$i++;
 }

 //Para mostrar a paginao coloque em sua pgina HTML ou PHP:***********************************************
 $paginacao->getAnterior("estilo_on","estilo_off");  //Cria boto anterior, os estilos referidos so CSS
 $paginacao->getPaginas("estilo_paginas");           //Cria n de pg., os estilos referidos so CSS
 $paginacao->getProximo("estilo_on","estilo_off");   //Cria boto prximo, os estilos referidos so CSS

 //Sendo assim junte todos que o resultado seria:************************************************************
 $paginacao->getAnterior("paginacao_on","paginacao_off").$paginacao->getPaginas("paginacao_paginas").$paginacao->getProximo("paginacao_on","paginacao_off");

 //RESULTADO DEPENDE DO ESTILO******************************************************************************
 [ESTILO 1]
 < Anterior 1 2 3 4 [5] 6 7 8 Prximo >
 < Anterior 1 2 3 4 5 [6] 7 8 Prximo >
 o nmero de pginas total  mostrado sendo no exemplo 8 pginas . . .

 [ESTILO 2]
 << Primeiro < Anterior 1 2 3 [4] 5 6 7 Prximo > ltimo >>
 se tiver mais que 7 ele comea a tira 1 no comeo e adicionar 1 no fim . . .
 << Primeiro < Anterior 2 3 4 [5] 6 7 8 Prximo > ltimo >>

[FIM DO MODO DE USAR]=======================================================================================/
**/



//=====================\
//[ INICIO DA CLASSE ] |
//=====================/
class Paginacao {
	var $maximo; 																	//variavel de nmero de itens por pgina;
	var $pagina;																	//controle do nmero da pgina;
	var $mat;																			//variavel para calculo de pginas;
	var $inicio;																	//controle de exibio de itens inicio;
	var $paginas;																	//variavel para calculo de pginas;
	var $linhas;																	//nmero total de itens;
	var $anterior;																//controle de pgina anterior;
	var $proximo;																	//controle de proxima pgina;
	var $result;																	//result do sql;
	var $nPaginas 				= 0;										//nmero total de pginas;
	var $btn_primeiro 		= "&lt;&lt; Primeiro";	//texto do boto com o link para a primeiro pgina;
	var $btn_anterior 		= "&lt; Anterior";			//texto do boto com o link para pgina anterior;
	var $btn_proximo			=	"Prximo &gt;";				//texto do boto com o link para prxima pgina;
	var $btn_ultimo				=	"ltimo &gt;&gt;";		//texto do boto com o link para a ltima pgina;
	var $sp								=	"/;\\";								//separa botes de n pg. OBS: use ;(ponto e virgula para separar os lados);
	var $btn_primeiro_on	= true;									//ativa e desativa o boto primeiro (true|false);
	var $btn_ultimo_on		=	true;									//ativa e desativa o boto ltimo (true|false);
	var $estilo						=	2;										//define estilo de paginao;]
	var $urlAdicional;														//define url adicional passada por parmetro pela url;
	var $zero							=	true;									//coloca zero aos nmeros baixos de 10; 01 02...

	/* CONSTRUTOR */
	function Paginacao(){ }

	/* SETA O NUMERO DE ITENS POR PGINA */
	function setMaximo($var){
		$this->maximo = $var;
	}

	/* SETA SEPARADORES DE BOTES DE NMERO DE PGINAS */
	function setSP($var){
		$this->sp = $var;
	}

	/* SETA O TEXTO DO BOTO PRIMEIRO */
	function setBtnPrimeiro($var){
		$this->btn_primeiro = $var;
	}

	/* SETA O TEXTO DO BOTO ANTERIOR */
	function setBtnAnterior($var){
		$this->btn_anterior = $var;
	}

	/* SETA O TEXTO DO BOTO PROXIMO */
	function setBtnProximo($var){
		$this->btn_proximo = $var;
	}

	/* SETA O TEXTO DO BOTO LTIMO */
	function setBtnUltimo($var){
		$this->btn_ultimo = $var;
	}

	/* DEFINE SE O BOTO PRIMEIRO VAI SER EXIBIDO */
	function setBtnPrimeiroOn($var){
		$this->btn_primeiro_on = $var;
	}

	/* DEFINE SE O BOTO LTIMO VAI SER EXIBIDO */
	function setBtnUltimoOn($var){
		$this->btn_ultimo_on = $var;
	}

	/* DEFINE O ESTILO DE PAGINAO */
	function setEstilo($var){
		$this->estilo = $var;
	}
	
	/* DEFINE URL ADICIONAR PARMETROS PASSADOS PELA URL */
	function setUrlAdicional($var){
		$this->urlAdicional = $var;
	}
	
	/* ATIVA O ZERO */
	function setZero($var){
		$this->zero = $var;
	}

	/* INICIALIZAO DO OBJETO */
	function __start($db, $sql){
		if($this->maximo == ""){ //se no for setado nmero de itens por pgina pega o padro;
			$this->maximo = 10;
		}
		if($_REQUEST["pagina"] == "") {
			$this->pagina = "1"; //se pgina igual a branco seta pgina = 1;
		}else{
			$this->pagina = $_REQUEST["pagina"]; //pega o nmero da pgina passada por parmetro ex:?pagina=2;
		}
		$this->mat = $this->pagina - 1; //inicia com a linha zero do banco;
		$this->inicio = $this->mat * $this->maximo; //calcula o valor de inicio da lista de acordo com a pgina;

		$limita = $sql." LIMIT ".$this->inicio.",".$this->maximo; //gera o sql para pesquisa no banco com a limitao;
		$this->result = $db->Execute($limita); //executa sql com a limitao;

		$result = $db->Execute($sql); //executa sql sem a limitao;
		$this->linhas = $result->RecordCount(); //pega valor total de itens do banco;

		$this->paginas = ceil($this->linhas / $this->maximo) - 1; //pega nmero total de pginas pela quantidade mxima de itens;
		$this->nPaginas = $this->paginas; //guarda valor na variavel;

		$this->anterior = $this->pagina - 1; //informa o a pgina anterior;
		$this->proximo = $this->pagina + 1; //informa a prxima pgina;
	}

	/* RETORNA O RESULTADO DO SQL COM O LIMITE DE ITENS POR LINHA */
	function getResult(){
		return $this->result;
	}
	
	/* RETORNA NMERO DE ITENS POR PGINA */
	function getNporPg(){
		return $this->maximo;
	}
	
	/* RETORNA O NMERO TOTAL DE PGINAS */
	function getNtotalPg(){
		return ($this->nPaginas+1);
	}

	/* RETORNA O BOTO PRIMEIRO E O ANTERIOR */
	function getAnterior($on, $off){
		if($this->btn_primeiro_on == true){ //se boto primeiro ativado;
			if($this->pagina == 1){ //se  primeira pgina;
				echo "<span class=\"".$off."\">".$this->btn_primeiro."</span> "; //boto off
			}else{
				if($this->urlAdicional != ""){
					echo "<span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=1\">".$this->btn_primeiro."</a></span> "; //boto on
				}else{
					echo "<span class=\"".$on."\"><a href=\"?pagina=1\">".$this->btn_primeiro."</a></span> "; //boto on
				}
			}
		}
		if($this->anterior > 0){ //se anterior maior que 0;
			if($this->urlAdicional != ""){
				echo "<span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=".$this->anterior."\">".$this->btn_anterior."</a></span> "; //boto on
			}else{
				echo "<span class=\"".$on."\"><a href=\"?pagina=".$this->anterior."\">".$this->btn_anterior."</a></span> "; //boto on
			}
		}else{
			echo "<span class=\"".$off."\">".$this->btn_anterior."</span> "; //boto off
		}
	}

	/* RETORNA O NMERO DE PGINAS PARA NAVEGAO */
	function getPaginas($on){
		$sp = explode(";", $this->sp); //pega variaves de separao de botes de n de pg;

		//===============================================================\
		//[ EXIBE PAGINAO NO ESTILO                                  ] |
		//[ < Anterior 1 2 3 4 [5] 6 7 8 Prximo >                     ] |
		//[ < Anterior 1 2 3 4 5 [6] 7 8 Prximo >                     ] |
		//[ o nmero de pginas total  mostrado . . .                 ] |
		//===============================================================|
		if($this->estilo == 1){
			echo" <b>".$sp[0]."</b> ";
			for($i=0; $i <= $this->nPaginas; $i++){
				$pag =  $i +1;
				if($this->urlAdicional != ""){
					echo " <span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=".$pag."\">";
				}else{
					echo " <span class=\"".$on."\"><a href=\"?pagina=".$pag."\">";
				}
				if($this->zero == true && $pag < 10){
					$pag = "0".$pag;
				}
				if($pag == $this->pagina){
					echo "[<b>".$pag."</b>]";
				}else{
					echo $pag;
				}
				echo "</a></span> ";
			}
			echo" <b>".$sp[1]."</b> ";
		}
		//===============================================================|
		//[ FIM PG 01 ]                                                  |
		//===============================================================/

		//===============================================================\
		//[ EXIBE PAGINAO NO ESTILO                                  ] |
		//[ << Primeiro < Anterior 1 2 3 [4] 5 6 7 Prximo > ltimo >> ] |
		//[ << Primeiro < Anterior 2 3 4 [5] 6 7 8 Prximo > ltimo >> ] |
		//===============================================================|
		if($this->estilo == 2){
			echo" <b>".$sp[0]."</b> "; //separador
			if($this->pagina < 5){
				$i = 0;
				if($this->nPaginas > 5){
					$j = 6;
				}else{
					$j = $this->nPaginas;
				}
			}else{
				if($this->pagina == 5 && $this->nPaginas <= 5){
					$i = 0;
					$j = $this->pagina - 1;
				}else{
					if($this->pagina <= ($this->nPaginas + 1)){
						$i = ($this->pagina - 4);
						$j = $this->pagina + 2;
						if($j > $this->nPaginas){
							if($this->pagina == ($this->nPaginas+1)){
								$j = $this->pagina - 1;
								$teste = ($this->nPaginas + 3) - $j;
								$i = $i - $teste;
							}else{
								if($this->pagina == 6){
									//[INICIO][correo 18/05/2008]
									if($this->getNtotalPg() == 8){
										$i = ($i - 1);
										$j = $this->pagina + 1;
									}else{ 
										$i = ($i - 2); //[correo 17/05/2008]
										$j = $this->pagina + 0;
									}
									//[FIM][correo 18/05/2008]
								}else{
									$i = ($this->pagina - 5);
									if($j > $this->nPaginas){
										$j = $this->nPaginas;
										if(($this->pagina+1) == ($this->nPaginas+1)){
											$teste = ($this->nPaginas + 1) - $j;
											$i = $i - $teste;
										}
									}
								}
							}
						}
					}else{
						$i = 0;
						$j = $this->nPaginas;
					}
				}
			}
			for($i; $i <= $j; $i++){
				$pag =  $i +1;
				if($this->urlAdicional != ""){
					echo " <span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=".$pag."\">";
				}else{
					echo " <span class=\"".$on."\"><a href=\"?pagina=".$pag."\">";
				}
				if($this->zero == true && $pag < 10){
					$pag = "0".$pag;
				}
				if($pag == $this->pagina){
					echo "[<b>".$pag."</b>]";
				}else{
					echo $pag;
				}
				echo "</a></span> ";
			}
			echo" <b>".$sp[1]."</b> "; //separador;
		}
		//===============================================================|
		//[ FIM PG 02 ]                                                  |
		//===============================================================/
	}

	/* RETORNA O BOTO PROXIMO E O LTIMO */
	function getProximo($on, $off){
		if($this->pagina <= $this->paginas){ //se pgina menor ou igual a numero total de pginas;
			if($this->urlAdicional != ""){
				echo "<span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=".$this->proximo."\">".$this->btn_proximo."</a></span> "; //boto on
			}else{
				echo "<span class=\"".$on."\"><a href=\"?pagina=".$this->proximo."\">".$this->btn_proximo."</a></span> "; //boto on
			}
		}else{
			echo "<span class=\"".$off."\">".$this->btn_proximo."</span> "; //boto off
		}
		if($this->btn_ultimo_on == true){ //se boto ltimo ativado
			if($this->pagina > $this->nPaginas){ //se pgina maior que nmero total de pginas;
				echo "<span class=\"".$off."\">".$this->btn_ultimo."</span> "; //boto off;
			}else{
				if($this->urlAdicional != ""){
					echo "<span class=\"".$on."\"><a href=\"?".$this->urlAdicional."&pagina=".($this->nPaginas+1)."\">".$this->btn_ultimo."</a></span> "; //boto on
				}else{
					echo "<span class=\"".$on."\"><a href=\"?pagina=".($this->nPaginas+1)."\">".$this->btn_ultimo."</a></span> "; //boto on
					}
			}
		}
	}
}
//==================\
//[ FIM DA CLASSE ] |
//==================/

?>